import 'package:json_schema/json_schema.dart';

main() {
  var schema = JsonSchema.create({
    "\$schema": "https://json-schema.org/draft/2020-12/schema",
    "type": "object",
    "additionalProperties": false,
    "properties": {
      "program": {"\$ref": "#/\$defs/program"}
    },
    "\$defs": {
      "program": {
        "properties": {
          "name": {"type": "string"},
          "sections": {
            "type": "array",
            "items": {"\$ref": "#/\$defs/section"}
          }
        },
        "required": ["name", "sections"],
        "additionalProperties": false
      },
      "section": {
        "properties": {
          "name": {"type": "string"},
          "sections": {
            "type": "array",
            "items": {"\$ref": "#/\$defs/section"}
          },
          "topics": {
            "type": "array",
            "items": {"\$ref": "#/\$defs/topic"}
          }
        }
      },
      "topic": {
        "properties": {
          "name": {"type": "string"}
        }
      }
    }
  });

  final validation = schema.validate({
    "program": {"name": 123}
  });

  if (validation.errors.isNotEmpty) print('Errors:');
  validation.errors.forEach((error) => print(error));
  print('Is JSON Valid? : ${validation.isValid}');
}
